#include <stdio.h>

/* motest.c
   
   This is my attempt to provide for MMX acceleration in the motion estimation
   kernel of the Berkeley MPEG-1 encoder.  
   
   Josh Pieper, josh@nemonet.com
   
*/


void inline mmx_start_block()
{
	asm(" 
		pxor %%mm7,%%mm7; 
		pxor %%mm6,%%mm6;
		" : : );
}

void inline mmx_absdiff(unsigned char *a, unsigned int *b)
{
	
	
	asm("	

		movq	(%%ebx),%%mm0;
		
		movq	8(%%ecx),%%mm2;
		movq	(%%ecx),%%mm1;
		packssdw	%%mm2,%%mm1;
		
		movq	24(%%ecx),%%mm3;
		movq	16(%%ecx),%%mm2;
		packssdw	%%mm3,%%mm2;

		packuswb	%%mm2,%%mm1;	
		
		movq	40(%%ecx),%%mm5;	
		movq	32(%%ecx),%%mm4;	
		packssdw	%%mm5,%%mm4;

		movq	56(%%ecx),%%mm5
		movq	48(%%ecx),%%mm3;	
		packssdw	%%mm5,%%mm3

		packuswb	%%mm3,%%mm4
		
		movq	%%mm0,%%mm2;		
		movq	8(%%ebx),%%mm3;		
		psubusb	%%mm1,%%mm0;
		psubusb	%%mm2,%%mm1;

		por	%%mm1,%%mm0;
		movq	%%mm3,%%mm5;		
		movq	%%mm0,%%mm1;		
		psubusb	%%mm4,%%mm3;
		punpcklbw	%%mm6,%%mm0;	
		psubusb	%%mm5,%%mm4;
		psrlq	$32,%%mm1;		
		por	%%mm4,%%mm3;
		punpcklbw	%%mm6,%%mm1;
		movq	%%mm3,%%mm4;		
		punpcklbw	%%mm6,%%mm3;	
		paddw	%%mm0,%%mm7;
		psrlq	$32,%%mm4;		
		paddw	%%mm1,%%mm7;
		punpcklbw	%%mm6,%%mm4;	
		paddw	%%mm3,%%mm7;
		paddw	%%mm4,%%mm7;
		
		
		" 
		: : "b" (a), "c" (b) 
		: "st"  );

}


unsigned int mmx_accum()
{
	unsigned long long r;
	
	asm("
		movq	%%mm7,%%mm5;
		movq	%%mm7,%%mm4;
		
		punpcklwd	%%mm6,%%mm4;
		punpckhwd	%%mm6,%%mm5;
		paddd		%%mm5,%%mm4;
		
		movq	%%mm4,%%mm5;
		
		punpckldq	%%mm6,%%mm5;
		punpckhdq	%%mm6,%%mm4;
		paddd	%%mm5,%%mm4;
		
		movq	%%mm4,(%%ebx);
		
		emms;
		"
		: :  "b" (&r) );
	return r;
}		

void inline mmx_avgdiff(unsigned char *a, unsigned long *b, unsigned long *c)
{
	asm("
		movq 	(%%ebx),%%mm4;		pxor	%%mm5,%%mm5;
		pcmpeqw	%%mm3,%%mm3;		movq	%%mm4,%%mm0;		
		movq	8(%%ecx),%%mm2;		psubw	%%mm3,%%mm5;
		movq	(%%ecx),%%mm1;		punpcklbw	%%mm6,%%mm0;
		movq	8(%%edx),%%mm3;		packssdw	%%mm2,%%mm1;
		movq	(%%edx),%%mm2;		paddw	%%mm5,%%mm1;
		
		paddw	%%mm1,%%mm0;		
		
		psraw	$1,%%mm0;
				
		packssdw	%%mm3,%%mm2;	movq	%%mm0,%%mm1;
		psubusb	%%mm2,%%mm1;		psubusb	%%mm0,%%mm2;
		por	%%mm2,%%mm1;		psrlq   $32,%%mm4;
                
                
		
                movq	24(%%ecx),%%mm2;        paddw	%%mm1,%%mm7;
                movq	16(%%ecx),%%mm1;        punpcklbw	%%mm6,%%mm4;

                movq	24(%%edx),%%mm3;        packssdw        %%mm2,%%mm1;	

                movq	16(%%edx),%%mm2;        paddw	%%mm5,%%mm4;
                packssdw	%%mm3,%%mm2;    paddw	%%mm4,%%mm1;                
                
                psraw	$1,%%mm1;		movq	%%mm2,%%mm3;
                
                psubusb	%%mm1,%%mm2;
                psubusb	%%mm3,%%mm1;
                por	%%mm1,%%mm2;
                
                paddw	%%mm2,%%mm7;
                
                "
                : : "b" (a) , "c" (b) , "d" (c) );
}
                 				                         		        				